/[gentoo-x86]/eclass/font.eclass
Gentoo

Diff of /eclass/font.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.49
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/font.eclass,v 1.23 2007/06/24 06:15:21 dirtyepic Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/font.eclass,v 1.49 2010/04/20 04:06:59 dirtyepic Exp $
4 4
5# @ECLASS: font.eclass
6# @MAINTAINER:
7# fonts@gentoo.org
8
9# Author: Tomáš Chvátal <scarabeus@gentoo.org>
5# Author: foser <foser@gentoo.org> 10# Author: foser <foser@gentoo.org>
6
7# Font Eclass
8#
9# Eclass to make font installation uniform 11# @BLURB: Eclass to make font installation uniform
10 12
11inherit eutils 13inherit eutils
12 14
13# 15EXPORT_FUNCTIONS pkg_setup src_install pkg_postinst pkg_postrm
14# Variable declarations
15#
16 16
17# @ECLASS-VARIABLE: FONT_SUFFIX
18# @DESCRIPTION:
17FONT_SUFFIX="" # Space delimited list of font suffixes to install 19# Space delimited list of font suffixes to install
20FONT_SUFFIX=${FONT_SUFFIX:=}
18 21
22# @ECLASS-VARIABLE: FONT_S
23# @DESCRIPTION:
19FONT_S="${S}" # Dir containing the fonts 24# Dir containing the fonts
25FONT_S=${FONT_S:=${S}}
20 26
21FONT_PN="${PN}" # Last part of $FONTDIR 27# @ECLASS-VARIABLE: FONT_PN
28# @DESCRIPTION:
29# Last part of $FONTDIR
30FONT_PN=${FONT_PN:=${PN}}
22 31
23FONTDIR="/usr/share/fonts/${FONT_PN}" # this is where the fonts are installed 32# @ECLASS-VARIABLE: FONTDIR
33# @DESCRIPTION:
34# This is where the fonts are installed
35FONTDIR=${FONTDIR:-/usr/share/fonts/${FONT_PN}}
24 36
37# @ECLASS-VARIABLE: FONT_CONF
38# @DESCRIPTION:
39# Array, which element(s) is(are) path(s) of fontconfig-2.4 file(s) to install
40FONT_CONF=( "" )
41
42# @ECLASS-VARIABLE: DOCS
43# @DESCRIPTION:
25DOCS="" # Docs to install 44# Docs to install
45DOCS=${DOCS:-}
26 46
27IUSE="X" 47IUSE="X"
28 48
29DEPEND="X? ( x11-apps/mkfontdir ) 49DEPEND="X? (
50 x11-apps/mkfontdir
51 media-fonts/encodings
52 )
30 media-libs/fontconfig" 53 >=media-libs/fontconfig-2.4.0"
31 54
32# 55# @FUNCTION: font_xfont_config
33# Public functions 56# @DESCRIPTION:
34# 57# Creates the Xfont files.
35
36font_xfont_config() { 58font_xfont_config() {
37
38 # create Xfont files 59 # create Xfont files
39 if use X ; then 60 if has X ${IUSE//+} && use X ; then
40 einfo "Creating fonts.scale & fonts.dir ..." 61 ebegin "Creating fonts.scale & fonts.dir"
62 rm -f "${ED}${FONTDIR}"/fonts.{dir,scale}
41 mkfontscale "${D}${FONTDIR}" 63 mkfontscale "${ED}${FONTDIR}"
42 mkfontdir \ 64 mkfontdir \
43 -e /usr/share/fonts/encodings \ 65 -e ${EPREFIX}/usr/share/fonts/encodings \
44 -e /usr/share/fonts/encodings/large \ 66 -e ${EPREFIX}/usr/share/fonts/encodings/large \
45 "${D}${FONTDIR}" 67 "${ED}${FONTDIR}"
68 eend $?
46 if [ -e "${FONT_S}/fonts.alias" ] ; then 69 if [ -e "${FONT_S}/fonts.alias" ] ; then
47 doins "${FONT_S}/fonts.alias" 70 doins "${FONT_S}/fonts.alias"
48 fi 71 fi
49 fi 72 fi
50
51} 73}
52 74
75# @FUNCTION: font_fontconfig
76# @DESCRIPTION:
77# Installs the fontconfig config files of FONT_CONF.
53font_xft_config() { 78font_fontconfig() {
79 local conffile
80 if [[ -n ${FONT_CONF[@]} ]]; then
81 insinto /etc/fonts/conf.avail/
82 for conffile in "${FONT_CONF[@]}"; do
83 [[ -e ${conffile} ]] && doins ${conffile}
84 done
85 fi
86}
54 87
55 if ! has_version '>=media-libs/fontconfig-2.4'; then 88# @FUNCTION: font_cleanup_dirs
56 # create fontconfig cache 89# @DESCRIPTION:
57 einfo "Creating fontconfig cache ..." 90# Remove any font directories only containing generated files.
58 # Mac OS X has fc-cache at /usr/X11R6/bin 91# Runs in pkg_postrm.
59 HOME="/root" fc-cache -f "${D}${FONTDIR}" 92font_cleanup_dirs() {
93 local genfiles="encodings.dir fonts.alias fonts.cache-1 fonts.dir fonts.scale"
94 local d f g generated candidate otherfile
95
96 ebegin "Purging empty font directories"
97 find -L "${EROOT}"usr/share/fonts/ -type d -print0 | while read -d $'\0' d; do
98 candidate=false
99 otherfile=false
100 for f in "${d}"/*; do
101 generated=false
102 [[ -e ${f} || -L ${f} ]] || continue
103 for g in ${genfiles}; do
104 if [[ ${f##*/} == ${g} ]]; then
105 generated=true
106 break
107 fi
108 done
109 ${generated} && candidate=true || otherfile=true
110 [[ ${candidate} == ${otherfile} ]] && break # both are true, keep the dir
111 done
112 if [[ ${candidate} == true && ${otherfile} == false ]]; then
113 ebegin "Removing ${d}"
114 rm -rf "${d}"
115 eend $?
60 fi 116 fi
117 done
118 eend 0
61} 119}
62 120
63# 121# @FUNCTION: font_src_install
64# Public inheritable functions 122# @DESCRIPTION:
65# 123# The font src_install function.
66
67font_src_install() { 124font_src_install() {
68
69 local suffix commondoc 125 local suffix commondoc
70 126
71 cd "${FONT_S}" 127 pushd "${FONT_S}" > /dev/null
72 128
73 insinto "${FONTDIR}" 129 insinto "${FONTDIR}"
74 130
75 for suffix in ${FONT_SUFFIX}; do 131 for suffix in ${FONT_SUFFIX}; do
76 doins *.${suffix} 132 doins *.${suffix}
77 done 133 done
78 134
79 rm -f fonts.{dir,scale} encodings.dir 135 rm -f fonts.{dir,scale} encodings.dir
80 136
81 font_xfont_config 137 font_xfont_config
82 font_xft_config 138 font_fontconfig
83 139
84 cd "${S}" 140 popd > /dev/null
85 dodoc ${DOCS} 2> /dev/null 141
142 [[ -n ${DOCS} ]] && { dodoc ${DOCS} || die "docs installation failed" ; }
86 143
87 # install common docs 144 # install common docs
88 for commondoc in COPYRIGHT README NEWS AUTHORS BUGS ChangeLog; do 145 for commondoc in COPYRIGHT README{,.txt} NEWS AUTHORS BUGS ChangeLog FONTLOG.txt; do
89 [ -s ${commondoc} ] && dodoc ${commondoc} 146 [[ -s ${commondoc} ]] && dodoc ${commondoc}
90 done 147 done
91} 148}
92 149
150# @FUNCTION: font_pkg_setup
151# @DESCRIPTION:
152# The font pkg_setup function.
153# Collision portection and Prefix compat for eapi < 3.
93font_pkg_setup() { 154font_pkg_setup() {
155 # Prefix compat
156 case ${EAPI:-0} in
157 0|1|2)
158 if ! use prefix; then
159 EPREFIX=
160 ED=${D}
161 EROOT=${ROOT}
162 [[ ${EROOT} = */ ]] || EROOT+="/"
163 fi
164 ;;
165 esac
94 166
95 # make sure we get no colissions 167 # make sure we get no collisions
96 # setup is not the nicest place, but preinst doesn't cut it 168 # setup is not the nicest place, but preinst doesn't cut it
97 [[ -e "${FONTDIR}/fonts.cache-1" ]] && rm -f "${FONTDIR}/fonts.cache-1" 169 [[ -e "${EROOT}/${FONTDIR}/fonts.cache-1" ]] && rm -f "${EROOT}/${FONTDIR}/fonts.cache-1"
98
99} 170}
100 171
172# @FUNCTION: font_pkg_postinst
173# @DESCRIPTION:
174# The font pkg_postinst function.
175# Update global font cache and fix permissions.
101font_pkg_postinst() { 176font_pkg_postinst() {
177 # unreadable font files = fontconfig segfaults
178 find "${EROOT}"usr/share/fonts/ -type f '!' -perm 0644 -print0 \
179 | xargs -0 chmod -v 0644 2>/dev/null
102 180
103 if has_version '>=media-libs/fontconfig-2.4'; then 181 if [[ -n ${FONT_CONF[@]} ]]; then
182 local conffile
183 echo
184 elog "The following fontconfig configuration files have been installed:"
185 elog
186 for conffile in "${FONT_CONF[@]}"; do
187 if [[ -e ${EROOT}etc/fonts/conf.avail/$(basename ${conffile}) ]]; then
188 elog " $(basename ${conffile})"
189 fi
190 done
191 elog
192 elog "Use \`eselect fontconfig\` to enable/disable them."
193 echo
194 fi
195
104 if [ ${ROOT} == "/" ]; then 196 if [[ ${ROOT} == / ]]; then
105 ebegin "Updating global fontcache" 197 ebegin "Updating global fontcache"
106 fc-cache -s 198 fc-cache -fs
107 eend $? 199 eend $?
108 fi 200 fi
109 fi
110
111} 201}
112 202
203# @FUNCTION: font_pkg_postrm
204# @DESCRIPTION:
205# The font pkg_postrm function.
206# Updates global font cache
113font_pkg_postrm() { 207font_pkg_postrm() {
208 font_cleanup_dirs
209
210 # unreadable font files = fontconfig segfaults
211 find "${EROOT}"usr/share/fonts/ -type f '!' -perm 0644 -print0 \
212 | xargs -0 chmod -v 0644 2>/dev/null
114 213
115 if has_version '>=media-libs/fontconfig-2.4'; then
116 if [ ${ROOT} == "/" ]; then 214 if [[ ${ROOT} == / ]]; then
117 ebegin "Updating global fontcache" 215 ebegin "Updating global fontcache"
118 fc-cache -s 216 fc-cache -fs
119 eend $? 217 eend $?
120 fi 218 fi
121 fi
122
123} 219}
124
125EXPORT_FUNCTIONS src_install pkg_setup pkg_postinst pkg_postrm

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.49

  ViewVC Help
Powered by ViewVC 1.1.20